# -*- coding: utf-8 -*-
"""
Created on Tue Jan 21 15:37:09 2020

@author: mendez
"""

# Exercise 3

import sympy as sym # For Symbolic Calculus
from sympy import exp, sin, Heaviside,  Symbol # Define symbolic functions of interest
# Import Laplace and Inverse Laplace Transforms
from sympy.integrals import laplace_transform
from sympy.integrals import inverse_laplace_transform
# Define symbols needed
h, t,s = sym.symbols('h t s')
# We give some additional (helpful info)
t=Symbol('t',positive=True)
h=1/2*exp(-t)*sin(2*t)*Heaviside(t) # Impulse Response
u=exp(-t)*Heaviside(t) # Input
# Compute Laplace Transforms
H=laplace_transform(h, t, s); print(H[0])
# Find Poles
p_ns=sym.roots(1.0*s**2 + 2.0*s + 5.0); print(p_ns)
U=laplace_transform(u, t, s); print(U[0])
# Hence the output is
Y=U[0]*H[0]; print(Y)
Y_e=sym.apart(Y); print(Y_e)
# Compute the inverse transform
#y=inverse_laplace_transform(Y_e,s,t); print(y)


import matplotlib.pyplot as plt  # Matplotlib is for plotting.
# Integrate the recursive formula
import numpy as np

# Run exercise for fs=10Hz
T=10; dt=1/10
t_k_1=np.arange(0,T,dt); # prepare the time axis
n_t=len(t_k_1)
Y_V_1=np.zeros(n_t)
a_11=-2*np.exp(-dt)*np.cos(2*dt)
a_21=np.exp(-2*dt)
K_11=1/5*(1+a_11+a_21)
u=np.exp(-dt)
for k in range(0,n_t):
 if k<1:
  Y_V_1[k]= K_11*u**k
 else:
  Y_V_1[k]=K_11*u**k-a_11*Y_V_1[k-1]-a_21*Y_V_1[k-2]
  
  
# Run exercise for fs=10Hz
T=10; dt=1/3
t_k_2=np.arange(0,T,dt); # prepare the time axis
n_t=len(t_k_2)
Y_V_2=np.zeros(n_t)
a_12=-2*np.exp(-dt)*np.cos(2*dt)
a_22=np.exp(-2*dt)
K_12=1/5*(1+a_12+a_22)
u=np.exp(-dt)
for k in range(0,n_t):
 if k<1:
  Y_V_2[k]= K_12*u**k
 else:
  Y_V_2[k]=K_12*u**k-a_12*Y_V_2[k-1]-a_22*Y_V_2[k-2]

# For comparison purposes, we include the analytical solution
  y=-0.25*(np.cos(2*t_k_1)-1)*np.exp(-t_k_1)



# Compare the two discrete systems
fig, ax = plt.subplots(figsize=(5, 3)) # This creates the figure
ax.spines['top'].set_visible(False)
ax.spines['right'].set_visible(False)
plt.rc('text', usetex=True)      
plt.rc('font', family='serif')
plt.plot(t_k_1,y,'-',label='$y(t)$')
plt.plot(t_k_1,Y_V_1,'ko',label='$y_{10}[k]$')
plt.plot(t_k_2,Y_V_2,'rs',label='$y_{3}[k]$')
ax.set_xlabel('$t_k$',fontsize=14)
ax.set_xlim(0,5)
ax.legend(fontsize=16)
plt.tight_layout()
Name='Ex3_.pdf'
plt.savefig(Name, dpi=200) 
#shutil.copyfile(Name,'../Figures/'+Name) #  copy file to latex directory








